<?php
helper::importControl('file');
class myfile extends file
{
    public $wordContent   = '';
    public $imgExtensions = array();
    public $relsID        = array();
    public $wrPr          = '<w:rPr><w:rFonts w:hint="eastAsia"/><w:lang w:val="en-US" w:eastAsia="zh-CN"/></w:rPr>';
    public $wpPr          = '';

    /**
     * Export to usage report.
     *
     * @access public
     * @return void
     */
    public function exportUsageReport()
    {
        $this->app->loadLang('usagereport');
        $this->app->loadLang('project');

        $users        = $this->loadModel('user')->getPairs('noletter');
        $sysURL       = common::getSysURL();
        $report       = $this->post->report;
        $projectPairs = $this->post->projectPairs;
        $lastReport   = $this->post->lastReport;

        $this->app->loadClass('pclzip', true);
        $this->wpPr   = "<w:pPr>{$this->wrPr}</w:pPr>";
        $this->zfile  = $this->app->loadClass('zfile');
        $this->relsID[6] = '';

        /* Init excel file. */
        $this->exportPath = $this->app->getCacheRoot() . $this->app->user->account . $this->post->kind . uniqid() . '/';
        if(is_dir($this->exportPath)) $this->zfile->removeDir($this->exportPath);
        $this->zfile->mkdir($this->exportPath);
        $this->zfile->copyDir($this->app->getCoreLibRoot() . 'word', $this->exportPath);

        $this->kind = $this->post->kind;
        $this->host = common::getSysURL();

        $headerName = sprintf($this->lang->usageReport->dateForm, $report->year, $report->month) . $this->lang->usageReport->title;
        $this->setDocProps($headerName);

        if($headerName)
        {
            $this->addTitle($headerName, 11, 'center');
            $this->wordContent .= '<w:p><w:pPr><w:jc w:val="center"/>' . $this->wrPr . '</w:pPr>';

            $begin = $this->lang->usageReport->begin . ' ' . date('Y-m-01', strtotime("$report->year-$report->month"));
            $end   = $this->lang->usageReport->end   . ' ' . date('Y-m-t',  strtotime("$report->year-$report->month"));
            $this->addText($begin . '    ' . $end, array('color' => 'CCCCCC'), true);
            $this->wordContent .= '</w:p>';
        }
        $this->addTextBreak(1);

        $this->addTitle($this->lang->usageReport->usageDataAnalysis, 2);
        $this->wordContent .= '<w:tbl>';
        $this->wordContent .= '<w:tblPr><w:tblStyle w:val="a3"/><w:tblW w:w="0" w:type="auto"/><w:tblLayout w:type="fixed"/><w:tblLook w:val="04A0"/></w:tblPr><w:tblGrid><w:gridCol w:w="5000"/><w:gridCol w:w="5000"/></w:tblGrid>';
        //$this->wordContent .= '<w:tr w:rsidR="0000463B" w:rsidTr="0000463B">';
        //$this->addTh($this->lang->usageReport->licenseType);
        //$this->addTd(zget($this->lang->usageReport->licenseTypeList, $report->licenseType));
        //$this->wordContent .= '</w:tr>';
        //$this->wordContent .= '<w:tr w:rsidR="0000463B" w:rsidTr="0000463B">';
        //$this->addTh($this->lang->usageReport->licensedAccounts);
        //$this->addTd(!empty($report->licensedAccounts) ? $report->licensedAccounts : $this->lang->unlimited);
        //$this->wordContent .= '</w:tr>';
        $this->wordContent .= '<w:tr w:rsidR="0000463B" w:rsidTr="0000463B">';
        $this->addTh($this->lang->usageReport->currentVersion);
        $this->addTd(str_replace(array('pms', 'pro', 'biz', 'max'), array($this->lang->pmsName, $this->lang->proName, $this->lang->bizName, $this->lang->maxName), $report->version));
        $this->wordContent .= '</w:tr>';
        $this->wordContent .= '<w:tr w:rsidR="0000463B" w:rsidTr="0000463B">';
        $this->addTh($this->lang->usageReport->onlineDays);
        $this->addTd($report->onlineDays . $this->lang->report->day);
        $this->wordContent .= '</w:tr>';
        $this->wordContent .= '<w:tr w:rsidR="0000463B" w:rsidTr="0000463B">';
        $this->addTh($this->lang->usageReport->activeProduct);
        $this->addTd($report->activeProduct);
        $this->wordContent .= '</w:tr>';
        $this->wordContent .= '<w:tr w:rsidR="0000463B" w:rsidTr="0000463B">';
        $this->addTh($this->lang->usageReport->activeProject);
        $this->addTd($report->activeProject);
        $this->wordContent .= '</w:tr>';
        $this->wordContent .= '<w:tr w:rsidR="0000463B" w:rsidTr="0000463B">';
        $this->addTh($this->lang->usageReport->projectModel);
        $this->addTd(str_replace(array('scrum', 'waterfall', 'kanban'), array($this->lang->project->scrum, $this->lang->project->waterfall, $this->lang->project->kanban), $report->projectModel));
        $this->wordContent .= '</w:tr>';
        $this->wordContent .= '</w:tbl>';
        $this->addTextBreak(1);

        $this->addTitle($this->lang->usageReport->activeAccountAnalysis, 3);
        $this->wordContent .= '<w:tbl>';
        $this->wordContent .= '<w:tblPr><w:tblStyle w:val="a3"/><w:tblW w:w="0" w:type="auto"/><w:tblLayout w:type="fixed"/><w:tblLook w:val="04A0"/></w:tblPr>';
        $this->wordContent .= '<w:tblGrid><w:gridCol w:w="2500"/><w:gridCol w:w="2500"/><w:gridCol w:w="2500"/><w:gridCol w:w="2500"/></w:tblGrid>';
        $this->wordContent .= '<w:tr w:rsidR="0000463B" w:rsidTr="0000463B">';
        $this->addTh($this->lang->usageReport->month);
        $this->addTh($this->lang->usageReport->activeAccounts);
        $this->addTh($this->lang->usageReport->allAccounts);
        $this->addTh($this->lang->usageReport->activeProportion);
        $this->wordContent .= '</w:tr>';
        $this->wordContent .= '<w:tr w:rsidR="0000463B" w:rsidTr="0000463B">';
        $this->addTd($this->lang->usageReport->thisMonth);
        $this->addTd(!empty($report->activeAccounts->active) ? $report->activeAccounts->active : '0');
        $this->addTd(!empty($report->activeAccounts->total)  ? $report->activeAccounts->total  : '0');
        $this->addTd((!empty($report->activeAccounts->ratio) ? $report->activeAccounts->ratio  : '0') . '%');
        $this->wordContent .= '</w:tr>';
        $this->wordContent .= '<w:tr w:rsidR="0000463B" w:rsidTr="0000463B">';
        $this->addTd($this->lang->usageReport->lastMonth);
        $this->addTd(!empty($lastReport->activeAccounts->active) ? $lastReport->activeAccounts->active : '0');
        $this->addTd(!empty($lastReport->activeAccounts->total)  ? $lastReport->activeAccounts->total  : '0');
        $this->addTd((!empty($lastReport->activeAccounts->ratio) ? $lastReport->activeAccounts->ratio  : '0') . '%');
        $this->wordContent .= '</w:tr>';
        $this->wordContent .= '</w:tbl>';
        $this->addTextBreak(1);

        $this->addTitle($this->lang->usageReport->companyDailyAnalysis, 3);
        if(isset($_POST['monthLogin'])) $this->addImage($this->post->monthLogin);
        $this->addTextBreak(1);

        $this->addTitle($this->lang->usageReport->projectComparisonAnalysis, 3);
        $this->wordContent .= '<w:tbl>';
        $this->wordContent .= '<w:tblPr><w:tblStyle w:val="a3"/><w:tblW w:w="0" w:type="auto"/><w:tblLayout w:type="fixed"/><w:tblLook w:val="04A0"/></w:tblPr>';
        $this->wordContent .= '<w:tblGrid><w:gridCol w:w="2500"/><w:gridCol w:w="2500"/><w:gridCol w:w="2500"/><w:gridCol w:w="2500"/></w:tblGrid>';
        $this->wordContent .= '<w:tr w:rsidR="0000463B" w:rsidTr="0000463B">';
        $this->addTh($this->lang->report->project);
        $this->addTh($this->lang->usageReport->projectActiveAccounts);
        $this->addTh($this->lang->usageReport->projectAllAccounts);
        $this->addTh($this->lang->usageReport->activeProportion);
        $this->wordContent .= '</w:tr>';
        foreach($report->activeProjects as $projectID => $projectData)
        {
            $this->wordContent .= '<w:tr w:rsidR="0000463B" w:rsidTr="0000463B">';
            $this->addTd(zget($projectPairs, $projectID));
            $this->addTd(!empty($projectData->active) ? $projectData->active : '0');
            $this->addTd(!empty($projectData->total)  ? $projectData->total  : '0');
            $this->addTd((!empty($projectData->ratio) ? $projectData->ratio  : '0') . '%');
            $this->wordContent .= '</w:tr>';
        }
        $this->wordContent .= '</w:tbl>';
        $this->addTextBreak(1);

        $this->addTitle($this->lang->usageReport->projectDailyAnalysis, 3);
        if(isset($_POST['projectLogin'])) $this->addImage($this->post->projectLogin);

        $defaultImage   = '';
        $contentTypeXML = file_get_contents($this->exportPath . '[Content_Types].xml');
        foreach($this->imgExtensions as $imgExtension => $val) $defaultImage .= '<Default ContentType="image/' . $imgExtension . '" Extension="' . $imgExtension . '"/>';
        $contentTypeXML = str_replace('%defaultimage%', $defaultImage, $contentTypeXML);
        file_put_contents($this->exportPath . '[Content_Types].xml', $contentTypeXML);

        $imageRels    = '';
        $documentRels = file_get_contents($this->exportPath . 'word/_rels/document.xml.rels');
        foreach($this->relsID as $i => $extension)
        {
            if($extension) $imageRels .= '<Relationship Id="rId' . $i . '" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/image" Target="media/image' . $i . '.' . $extension . '"/>';
        }
        $documentRels = str_replace('%image%', $imageRels, $documentRels);
        file_put_contents($this->exportPath . 'word/_rels/document.xml.rels', $documentRels);

        $documentXML = file_get_contents($this->exportPath . 'word/document.xml');
        $sectPr = $this->post->direction == 'abeam' ? $this->config->word->sectPrAbeam : $this->config->word->sectProVertical;
        $documentXML = str_replace(array('%wordContent%', '%sectpr%'), array($this->wordContent, $sectPr), $documentXML);
        $documentXML = str_replace('<w:pgMar w:top="1440" w:right="1800" w:bottom="1440" w:left="1800" w:header="851" w:footer="992" w:gutter="0"/>',
            '<w:pgMar w:top="720" w:right="720" w:bottom="720" w:left="720" w:header="851" w:footer="992" w:gutter="0"/>', $documentXML);
        file_put_contents($this->exportPath . 'word/document.xml', $documentXML);

        /* Zip to xlsx. */
        $fileName = uniqid() . '.docx';
        helper::cd($this->exportPath);
        $files = array('[Content_Types].xml', '_rels', 'docProps', 'word', 'customXml');
        $zip   = new pclzip($fileName);
        $zip->create($files);

        $fileData = file_get_contents($this->exportPath . $fileName);
        $this->zfile->removeDir($this->exportPath);
        $this->sendDownHeader($this->post->fileName . '.docx', 'docx', $fileData);
        exit;
    }

    /**
     * Add title.
     *
     * @param  sting    $text
     * @param  int    $grade
     * @param  string $align
     * @access public
     * @return void
     */
    public function addTitle($text, $grade = 1, $align = 'left')
    {
        $this->wordContent .= "<w:p><w:pPr><w:pStyle w:val='$grade'/>";
        if($align != 'left') $this->wordContent .= "<w:jc w:val='$align'/>";
        $this->wordContent .= $this->wrPr . '</w:pPr>';
        $this->addText($text, array(), true);
        $this->wordContent .= '</w:p>';
    }

    /**
     * Add table.
     *
     * @param  array  $tableData
     * @param  array  $item
     * @param  string $style
     * @access public
     * @return void
     */
    public function addTable($tableData, $item, $style = 'block')
    {
        $itemLang    = $this->lang->report->item;
        $valueLang   = $this->lang->report->value;
        $leftWidth   = 2000;
        $centerWidth = 870;
        $rightWidth  = 1000;
        $tblBorders  = '<w:tblBorders><w:top w:space="0" w:sz="4" w:color="auto" w:val="single"/><w:left w:space="0" w:sz="4" w:color="auto" w:val="single"/><w:bottom w:space="0" w:sz="4" w:color="auto" w:val="single"/><w:right w:space="0" w:sz="4" w:color="auto" w:val="single"/><w:insideH w:space="0" w:sz="4" w:color="auto" w:val="single"/><w:insideV w:space="0" w:sz="4" w:color="auto" w:val="single"/></w:tblBorders>';
        $tblLayout   = '<w:tblLayout w:type="fixed"/>';
        $tblCellMar  = '<w:tblCellMar><w:left w:w="108" w:type="dxa"/><w:right w:w="108" w:type="dxa"/></w:tblCellMar>';
        $floatStyle  = '<w:tblpPr w:tblpY="100" w:tblpX="8000" w:horzAnchor="page" w:vertAnchor="text" w:rightFromText="180" w:leftFromText="180"/><w:tblOverlap w:val="never"/>';
        $document    = '<w:tbl>';
        if($item == 'bugStageGroups' or $item == 'bugHandleGroups')
        {
            $width     = $leftWidth * 3 + $rightWidth;
            $document .= '<w:tblPr>
                <w:tblStyle w:val="12"/>' . ($style == 'float' ? $floatStyle : '') . '
                <w:tblW w:w="' . $width . '" w:type="dxa"/><w:jc w:val="center"/>' . $tblBorders . $tblLayout . $tblCellMar . '</w:tblPr>
                <w:tblGrid><w:gridCol w:w="' . $rightWidth . '"/><w:gridCol w:w="' . $leftWidth . '"/><w:gridCol w:w="' . $leftWidth . '"/><w:gridCol w:w="' . $leftWidth . '"/></w:tblGrid>';
            $document .= '<w:tr><w:tblPrEx>' . $tblBorders . $tblLayout . $tblCellMar . '</w:tblPrEx>
                <w:trPr><w:trHeight w:val="287" w:hRule="atLeast"/></w:trPr>
                <w:tc>
                <w:tcPr><w:tcW w:w="' . $rightWidth . '" w:type="dxa"/></w:tcPr>
                <w:p>' . $this->wpPr . '<w:r>' . $this->wrPr . '<w:t><![CDATA[' . htmlspecialchars_decode($item == 'bugStageGroups' ? $this->lang->bug->pri : $this->lang->testreport->date, ENT_QUOTES) . ']]></w:t></w:r></w:p>
                </w:tc>
                <w:tc>
                <w:tcPr><w:tcW w:w="' . $leftWidth . '" w:type="dxa"/></w:tcPr>
                <w:p>' . $this->wpPr . '<w:r>' . $this->wrPr . '<w:t><![CDATA[' . htmlspecialchars_decode($this->lang->testreport->bugStageList['generated'], ENT_QUOTES) . ']]></w:t></w:r></w:p>
                </w:tc>
                <w:tc>
                <w:tcPr><w:tcW w:w="' . $leftWidth . '" w:type="dxa"/></w:tcPr>
                <w:p>' . $this->wpPr . '<w:r>' . $this->wrPr . '<w:t><![CDATA[' . htmlspecialchars_decode($this->lang->testreport->bugStageList['legacy'], ENT_QUOTES) . ']]></w:t></w:r></w:p>
                </w:tc>
                <w:tc>
                <w:tcPr><w:tcW w:w="' . $leftWidth . '" w:type="dxa"/></w:tcPr>
                <w:p>' . $this->wpPr . '<w:r>' . $this->wrPr . '<w:t><![CDATA[' . htmlspecialchars_decode($this->lang->testreport->bugStageList['resolved'], ENT_QUOTES) . ']]></w:t></w:r></w:p>
                </w:tc>
                </w:tr>';
        }
        else
        {
            $width     = $leftWidth + $centerWidth + $rightWidth;
            $document .= '<w:tblPr>
                <w:tblStyle w:val="9"/>' . ($style == 'float' ? $floatStyle : '') . '
                <w:tblW w:w="' . $width . '" w:type="dxa"/><w:jc w:val="center"/>' . $tblBorders . $tblLayout . $tblCellMar . '</w:tblPr>
                <w:tblGrid><w:gridCol w:w="' . $leftWidth . '"/><w:gridCol w:w="' . $centerWidth . '"/><w:gridCol w:w="' . $rightWidth . '"/></w:tblGrid>';
            $document .= '<w:tr><w:tblPrEx>' . $tblBorders . $tblLayout . $tblCellMar . '</w:tblPrEx>
                <w:trPr><w:trHeight w:val="287" w:hRule="atLeast"/></w:trPr>
                <w:tc>
                <w:tcPr><w:tcW w:w="' . $leftWidth . '" w:type="dxa"/></w:tcPr>
                <w:p>' . $this->wpPr . '<w:r>' . $this->wrPr . '<w:t><![CDATA[' . htmlspecialchars_decode($itemLang, ENT_QUOTES) . ']]></w:t></w:r></w:p>
                </w:tc>
                <w:tc>
                <w:tcPr><w:tcW w:w="' . $centerWidth . '" w:type="dxa"/></w:tcPr>
                <w:p>' . $this->wpPr . '<w:r>' . $this->wrPr . '<w:t><![CDATA[' . htmlspecialchars_decode($valueLang, ENT_QUOTES) . ']]></w:t></w:r></w:p>
                </w:tc>
                <w:tc>
                <w:tcPr><w:tcW w:w="' . $rightWidth . '" w:type="dxa"/></w:tcPr>
                <w:p>' . $this->wpPr . '<w:r>' . $this->wrPr . '<w:t><![CDATA[' . htmlspecialchars_decode($this->lang->report->percent, ENT_QUOTES) . ']]></w:t></w:r></w:p>
                </w:tc>
                </w:tr>';
        }
        foreach($tableData as $data)
        {
            if($item == 'bugStageGroups' or $item == 'bugHandleGroups')
            {
                $document .= '<w:tr><w:tblPrEx>' . $tblBorders . $tblLayout . $tblCellMar . '</w:tblPrEx>
                    <w:trPr><w:trHeight w:val="287" w:hRule="atLeast"/></w:trPr>
                    <w:tc>
                    <w:tcPr><w:tcW w:w="' . $rightWidth . '" w:type="dxa"/></w:tcPr>
                    <w:p>' . $this->wpPr . '<w:r>' . $this->wrPr . '<w:t><![CDATA[' . htmlspecialchars_decode($data->name, ENT_QUOTES) . ']]></w:t></w:r></w:p>
                    </w:tc>
                    <w:tc>
                    <w:tcPr><w:tcW w:w="' . $leftWidth . '" w:type="dxa"/></w:tcPr>
                    <w:p>' . $this->wpPr . '<w:r>' . $this->wrPr . '<w:t><![CDATA[' . htmlspecialchars_decode($data->generated, ENT_QUOTES) . ']]></w:t></w:r></w:p>
                    </w:tc>
                    <w:tc>
                    <w:tcPr><w:tcW w:w="' . $leftWidth . '" w:type="dxa"/></w:tcPr>
                    <w:p>' . $this->wpPr . '<w:r>' . $this->wrPr . '<w:t><![CDATA[' . htmlspecialchars_decode($data->legacy, ENT_QUOTES) . ']]></w:t></w:r></w:p>
                    </w:tc>
                    <w:tc>
                    <w:tcPr><w:tcW w:w="' . $leftWidth . '" w:type="dxa"/></w:tcPr>
                    <w:p>' . $this->wpPr . '<w:r>' . $this->wrPr . '<w:t><![CDATA[' . htmlspecialchars_decode($data->resolved, ENT_QUOTES) . ']]></w:t></w:r></w:p>
                    </w:tc>
                    </w:tr>';
            }
            else
            {
                $document .= '<w:tr><w:tblPrEx>' . $tblBorders . $tblLayout . $tblCellMar . '</w:tblPrEx>
                    <w:trPr><w:trHeight w:val="287" w:hRule="atLeast"/></w:trPr>
                    <w:tc>
                    <w:tcPr><w:tcW w:w="' . $leftWidth . '" w:type="dxa"/></w:tcPr>
                    <w:p>' . $this->wpPr . '<w:r>' . $this->wrPr . '<w:t><![CDATA[' . htmlspecialchars_decode($data->name, ENT_QUOTES) . ']]></w:t></w:r></w:p>
                    </w:tc>
                    <w:tc>
                    <w:tcPr><w:tcW w:w="' . $centerWidth . '" w:type="dxa"/></w:tcPr>
                    <w:p>' . $this->wpPr . '<w:r>' . $this->wrPr . '<w:t><![CDATA[' . htmlspecialchars_decode($data->value, ENT_QUOTES) . ']]></w:t></w:r></w:p>
                    </w:tc>
                    <w:tc>
                    <w:tcPr><w:tcW w:w="' . $rightWidth . '" w:type="dxa"/></w:tcPr>
                    <w:p>' . $this->wpPr . '<w:r>' . $this->wrPr . '<w:t><![CDATA[' . ($data->percent * 100) . '%' . ']]></w:t></w:r></w:p>
                    </w:tc>
                    </w:tr>';
            }
        }
        $document .= '</w:tbl>';

        $this->wordContent .= $document;
    }

    /**
     * Add th.
     *
     * @param  string $fieldName
     * @param  string $width
     * @access public
     * @return void
     */
    public function addTh($fieldName, $width = '1101')
    {
        $this->wordContent .= '<w:tc><w:tcPr></w:tcPr>';
        $this->wordContent .= '<w:p w:rsidR="0000463B" w:rsidRDefault="0000463B" w:rsidP="0000463B"><w:pPr><w:spacing w:line="220" w:lineRule="atLeast"/><w:jc w:val="left"/></w:pPr>';
        $this->wordContent .= '<w:r><w:rPr><w:rFonts w:hint="eastAsia"/><w:b/><w:bCs/></w:rPr>';
        $this->wordContent .= "<w:t><![CDATA[{$fieldName}]]></w:t>";
        $this->wordContent .= '</w:r></w:p></w:tc>';
    }

    /**
     * Add td.
     *
     * @param  string $content
     * @param  string $width
     * @access public
     * @return void
     */
    public function addTd($content, $width = '7421')
    {
        $this->wordContent .= '<w:tc><w:tcPr><w:vAlign w:val="center"/></w:tcPr>';
        $this->pauseHtmlTag($content);
        $this->wordContent .= '</w:tc>';
    }

    /**
     * Add text.
     *
     * @param  string $text
     * @param  array  $styles
     * @param  bool   $inline
     * @access public
     * @return void
     */
    public function addText($text, $styles = array(), $inline = false)
    {
        $out = array();
        preg_match_all("/<span .*style=([\"|\'])(.*)\\1>(.*)<\/span>/U", $text, $out);
        $noTags = preg_split("/<span .*style=([\"|\'])(.*)\\1>(.*)<\/span>/U", $text);
        if($out[2])
        {
            foreach($out[2] as $i => $styles)
            {
                $styles = explode(';', $styles);
                unset($out[2][$i]);
                foreach($styles as $style)
                {
                    if(empty($style)) continue;
                    if(strpos($style, ':') === false) continue;
                    list($key, $value) = explode(':', $style);

                    $out[2][$i][$key] = $value;
                }
            }

            foreach($noTags as $i => $content)
            {
                if($content)$this->addText($content, array(), true);

                if(!isset($out[3][$i])) continue;
                $content = trim($out[3][$i]);
                if(empty($content) and $content != 0) continue;
                $this->addText($content, $out[2][$i], true);
            }
            return false;
        }
        $text = trim(strip_tags($text));
        if(empty($text) and $text != 0) return false;
        $text     = htmlspecialchars_decode($text, ENT_QUOTES);
        $document = '';
        if(!$inline) $document .= '<w:p>' . $this->wpPr;
        $document .= '<w:r>';
        $document .= $this->transformStyle($styles);
        $document .= "<w:t><![CDATA[$text]]></w:t>";
        $document .= '</w:r>';
        if(!$inline) $document .= '</w:p>';
        $this->wordContent .= $document;
    }

    /**
     * Add image.
     *
     * @param  int    $path
     * @param  int    $inline
     * @access public
     * @return void
     */
    public function addImage($imageData, $extension = 'png')
    {
        $dir = $this->exportPath . 'word/media';
        if(!is_dir($dir)) mkdir($dir, 0777, true);

        $imageData = base64_decode(substr($imageData, strpos($imageData, 'base64,') + 7));
        if(empty($imageData)) return false;

        if(strpos($imageData, 'realpath;') === 0) $imageData = file_get_contents(substr($imageData, strlen('realpath;')));

        $this->imgExtensions[$extension] = true;
        $this->relsID[] = $extension;

        end($this->relsID);
        $relsID = key($this->relsID);

        $path = $dir . '/image' . $relsID . '.' . $extension;
        file_put_contents($path, $imageData);

        list($width, $height) = getimagesize($path);
        if($width > $this->config->word->maxImageWidth)
        {
            $height = ceil(($this->config->word->maxImageWidth / $width) * $height);
            $width  = $this->config->word->maxImageWidth;
        }

        $document  = '';
        $document .= '<w:p><w:pPr><w:jc w:val="center"/></w:pPr>';
        $document .= '<w:r><w:rPr><w:rFonts w:hint="eastAsia" /><w:kern w:val="2"/><w:sz w:val="21"/><w:lang w:val="en-US" w:eastAsia="zh-CN"/></w:rPr>';
        $document .= '<w:pict><v:shape id="pict' . $relsID . '" o:spid="_x0000_s1026" type="#_x0000_t75" style="height:' . $height . 'px;width:' . ($width - $width * 0.13) . 'px;rotation:0f;" o:ole="f" fillcolor="#FFFFFF" filled="f" o:preferrelative="t" stroked="f" coordorigin="0,0" coordsize="21600,21600"><v:fill on="f" color2="#FFFFFF" focus="0%"/>';
        $document .= '<v:imagedata gain="65536f" blacklevel="0f" gamma="0" o:title="5" r:id="rId' . $relsID . '"/>';
        $document .= '<o:lock v:ext="edit" position="f" selection="f" grouping="f" rotation="f" cropping="f" text="f" aspectratio="t"/><w10:wrap type="none"/><w10:anchorlock/></v:shape></w:pict></w:r>';
        $document .= '</w:p>';

        $this->wordContent .= $document;
    }

    /**
     * Add link.
     *
     * @param  string $text
     * @param  sting  $href
     * @param  array  $styles
     * @param  bool   $inline
     * @access public
     * @return void
     */
    public function addLink($text, $href, $styles = array(), $inline = false)
    {
        $document = '';
        $text     = htmlspecialchars_decode($text, ENT_QUOTES);
        $href     = preg_replace('/&(quot|#34);/i', '&', $href);
        if(!$inline) $document .= '<w:p>' . $this->wpPr;
        $document .= '<w:r>' . $this->wrPr . '<w:fldChar w:fldCharType="begin"/></w:r>';
        $document .= '<w:r>' . $this->wrPr . '<w:instrText xml:space="preserve">HYPERLINK "<![CDATA[' . $href . ']]>"</w:instrText></w:r>';
        $document .= '<w:r>' . $this->wrPr . '<w:fldChar w:fldCharType="separate"/></w:r>';
        $document .= '<w:r>';
        $document .= $this->transformStyle($styles);
        $document .= "<w:t><![CDATA[$text]]></w:t>";
        $document .= '</w:r><w:r>' . $this->wrPr . '<w:fldChar w:fldCharType="end"/></w:r>';
        if(!$inline) $document .= '</w:p>';
        $this->wordContent .= $document;
    }

    /**
     * Add text break.
     *
     * @param  int    $num
     * @access public
     * @return void
     */
    public function addTextBreak($num = 1)
    {
        $document = '';
        for($i = 0; $i < $num; $i++) $document .= '<w:p>' . $this->wpPr . '</w:p>';
        $this->wordContent .= $document;
    }

    /**
     * Transform style.
     *
     * @param  array  $styles
     * @access public
     * @return void
     */
    public function transformStyle($styles = array())
    {

        $wordStyle  = '<w:rPr>';
        if(isset($styles['font-family'])) $styles['font-family'] = str_replace(array('&', ';'), '', $styles['font-family']);
        $wordStyle .= isset($styles['font-family']) ? '<w:rFonts w:hint="eastAsia" w:ascii="' . $styles['font-family'] . '" w:hAnsi="' . $styles['font-family'] . '" w:eastAsia="' . $styles['font-family'] . '" w:cs="' . $styles['font-family'] . '"/>' : '<w:rFonts w:hint="eastAsia"/>';
        foreach($styles as $key => $value)
        {
            switch($key)
            {
            case 'font-style':
                $wordStyle .= '<w:i/><w:iCs/>';
                break;
            case 'font-weight':
                $wordStyle .= '<w:b/><w:bCs/>';
                break;
            case 'text-decoration':
                $wordStyle .= '<w:u w:val="single" w:color="auto"/>';
                break;
            case 'color':
                $wordStyle .= '<w:color w:val="' . substr($value, 1) .'"/>';
                break;
            case 'font-size':
                preg_match('/\d+(\.\d+)?/', $value, $out);
                $value = $out[0] * 2;
                $wordStyle .= '<w:sz w:val="' . $value . '"/><w:szCs w:val="' . $value . '"/>';
                break;
            }
        }
        $wordStyle .= '<w:lang w:val="en-US" w:eastAsia="zh-CN"/></w:rPr>';
        return $wordStyle;
    }

    /**
     * Set doc props.
     *
     * @access public
     * @return void
     */
    public function setDocProps($header)
    {
        $title      = $header ? $header : $this->post->kind;
        $coreFile   = file_get_contents($this->exportPath . 'docProps/core.xml');
        $createDate = date('Y-m-d') . 'T' . date('H:i:s') . 'Z';
        $account    = $this->app->user->account;
        $coreFile   = sprintf($coreFile, $createDate, $account, $account, $createDate, $title);
        file_put_contents($this->exportPath . 'docProps/core.xml', $coreFile);
    }

    /**
     * Pause line Html tag.
     *
     * @param  string $text
     * @access public
     * @return void
     */
    public function pauseLineHtmlTag($text)
    {
        $out = array();
        preg_match_all('/(<br ?(\/?)>)/U', $text, $out);
        $splitByBR = preg_split("/<br ?(\/?)>/U", $text);
        if($out[0])
        {
            foreach($splitByBR as $i => $content)
            {
                if($content) $this->pauseLineHtmlTag($content);

                if(!isset($out[1][$i])) continue;
                $this->wordContent .= '</w:p><w:p>' . $this->wpPr;
            }
            return false;
        }

        $out = array();
        preg_match_all("/<img .*src=([\"|\'])(.*)\\1 .*(\/?)>/U", $text, $out);
        $splitByIMG = preg_split("/<img .*src=([\"|\'])(.*)\\1 .*(\/?)>/U", $text);
        if($out[0])
        {
            foreach($splitByIMG as $i => $content)
            {
                if($content) $this->pauseLineHtmlTag($content);

                if(!isset($out[2][$i])) continue;
                $imgExtension = str_replace('data:image/', '', substr($out[2][$i], 0, strpos($out[2][$i], ';')));
                $isFixContent = preg_match('/<\/w:p>$/', $this->wordContent) == false;
                if($isFixContent) $this->wordContent = substr($this->wordContent, 0, strrpos($this->wordContent, '<w:p>'));
                $this->addImage($out[2][$i], $imgExtension);
                if($isFixContent) $this->wordContent = substr($this->wordContent, 0, strlen($this->wordContent) - 6);
            }
            return false;
        }

        $out = array();
        preg_match_all("/<a .*href=([\"|\'])(.*)\\1.*>(.*)<\/a>/U", $text, $out);
        $splitByA = preg_split("/<a .*href=([\"|\'])(.*)\\1.*>(.*)<\/a>/U", $text);
        if($out[0])
        {
            foreach($splitByA as $i => $content)
            {
                if($content) $this->pauseLineHtmlTag($content);

                if(!isset($out[3][$i])) continue;
                $content = trim($out[3][$i]);
                if(empty($content) and $content != 0) continue;
                $this->addLink($out[3][$i], $out[2][$i], array('color'=>'0000FF'), true);
            }
            return false;
        }

        $this->addText($text, array(), true);
    }

    /**
     * Format docx files.
     *
     * @param  int    $content
     * @access public
     * @return void
     */
    public function formatDocxFiles($content)
    {
        if(empty($content->files)) return;
        foreach($content->files as $file)
        {
            $linkHref  = $file->realPath;
            $extension = $file->extension;
            $linkName  = $file->title;
            if(in_array($extension, $this->config->word->imageExtension))
            {
                if(!file_exists($linkHref)) continue;
                $this->addImage("data:image/{$extension};base64," . base64_encode('realpath;' . $linkHref));
                $this->addTextBreak();
            }
            else
            {
                $this->addLink($linkName . ".$extension", common::getSysURL() . $this->createLink('file', 'download', "fileID={$file->id}"), array('color'=>'0000FF'));
            }
        }
    }

    /**
     * Check file exist.
     *
     * @param  string $matches
     * @access public
     * @return void
     */
    public function checkFileExist($matches)
    {
        $realFilePath = $this->config->word->filePath . $matches[2];
        preg_match_all('/^{(\d+)\.\w+}$/', $matches[2], $out);
        $imageData = '';
        if($out[0])
        {
            $file = $this->file->getById($out[1][0]);
            $realFilePath = $file->realPath;
            if(file_exists($realFilePath)) $imageData = "data:image/{$file->extension};base64," . base64_encode('realpath;' . $realFilePath);
        }
        return file_exists($realFilePath) ? '<img src="' . $imageData . '" alt="" />' : '';
    }

    /**
     * Pause Html tag.
     *
     * @param  string $content
     * @access public
     * @return void
     */
    public function pauseHtmlTag($content)
    {
        if($content == '')
        {
            $this->wordContent .= '<w:p><w:pPr><w:spacing w:line="220" w:lineRule="atLeast"/></w:pPr></w:p>';
            return false;
        }

        /* Change the tag of u em and stong to span. */
        $search       = array('<u>', '</u>', '<em>', '</em>', '<strong>', '</strong>', '<b>', '</b>', '&nbsp;');
        $replace      = array('<span style="text-decoration:underline">', '</span>', '<span style="font-style:italic">', '</span>', '<span style="font-weight:bold;">', '</span>', '<span style="font-weight:bold;">', '</span>', ' ');
        $isImage = strpos($content, '<img') !== false;
        $fieldContent = preg_replace_callback('/<img .*src=([\"|\'])(.+)\\1 .*(\/?)>/U', array(&$this, 'checkFileExist'), $content);
        $fieldContent = str_replace($search, $replace, $fieldContent);
        $fieldContent = str_replace("\n", '', $fieldContent);
        $fieldContent = str_replace(array("</li>", '</tr>', '<br />', '</p>'), "\n", $fieldContent);
        $fieldContent = preg_replace(array('/<h\d>/', '/<\/h\d>/'), array('', "\n"), $fieldContent);
        $fieldContent = strip_tags($fieldContent, '<a><img><span>');
        $fieldContent = explode("\n", $fieldContent);

        foreach($fieldContent as $text)
        {
            $this->wordContent .= '<w:p>' . $this->wpPr;
            $this->pauseLineHtmlTag($text);
            $this->wordContent .= '</w:p>';
        }
    }
}
