<?php
/**
 * The control file of report module of ZenTaoPMS.
 *
 * @copyright   Copyright 2009-2022 青岛易软天创网络科技有限公司 (QingDao Nature Easy Soft Network Technology Co,LTD www.cnezsoft.com)
 * @license     business(商业软件)
 * @author      Qiyu Xie <xieqiyu@easycorp.ltd>
 * @package     report
 * @version     $Id$
 * @link        https://www.zentao.net
 */
helper::importControl('report');
class myReport extends report
{
    /**
     * Export usage report.
     *
     * @param  string $year
     * @param  string $month
     * @access public
     * @return void
     */
    public function exportUsageReport($year, $month)
    {
        if(!empty($_POST))
        {
            $data = fixer::input('post')->get();
            if(empty($data->fileName)) die(js::alert($this->lang->usageReport->fileNameNotEmpty));

            $report       = $this->report->getUsageReportData($year, $month);
            $projectPairs = !empty($report->projectDailyActivity) ? $this->loadModel('project')->getPairsByIdList(array_keys($report->projectDailyActivity), 'all') : array();
            $lastReport   = $this->report->getUsageReportData(date('Y', strtotime("$year-$month -1 month")), date('m', strtotime("$year-$month -1 month")));

            $this->post->set('report', $report);
            $this->post->set('projectPairs', $projectPairs);
            $this->post->set('lastReport', $lastReport);
            $this->post->set('kind', 'usagereport');
            $this->fetch('file', 'exportusagereport', $_POST);
        }

        $this->app->loadLang('usageReport');
        $this->view->fileName = sprintf($this->lang->usageReport->dateForm, $year, $month) . $this->lang->usageReport->title;
        $this->view->year     = $year;
        $this->view->month    = $month;
        $this->display();
    }
}
