<?php
/**
 * The control file of report module of ZenTaoPMS.
 *
 * @copyright   Copyright 2009-2022 青岛易软天创网络科技有限公司 (QingDao Nature Easy Soft Network Technology Co,LTD www.cnezsoft.com)
 * @license     business(商业软件)
 * @author      Mengyi Liu <liumengyi@easycorp.ltd>
 * @package     report
 * @version     $Id$
 * @link        https://www.zentao.net
 */
helper::importControl('report');
class myReport extends report
{
    public function usageReport($year = '', $month = '')
    {
        $reportList = $this->report->getUsageReportList();
        if((empty($year) or empty($month)) and !empty($reportList))
        {
            $maxDate = $reportList[0];
            $year    = $maxDate->year;
            $month   = $maxDate->month;
        }

        $this->loadModel('project');
        $report       = $this->report->getUsageReportData($year, $month);
        $projectPairs = !empty($report->projectDailyActivity) ? $this->project->getPairsByIdList(array_keys($report->projectDailyActivity), 'all') : array();
        $lastReport   = $this->report->getUsageReportData(date('Y', strtotime("$year-$month -1 month")), date('m', strtotime("$year-$month -1 month")));

        $this->view->title          = $this->lang->usageReport->title;
        $this->view->year           = $year;
        $this->view->month          = $month;
        $this->view->report         = $report;
        $this->view->reportList     = $reportList;
        $this->view->projectPairs   = $projectPairs;
        $this->view->lastReport     = $lastReport;
        $this->view->selectProjects = array_slice(array_keys($projectPairs), 0, 3);
        $this->display();
    }
}
