$(function()
{
    if(report.length == 0) return;
    window.usageReport = JSON.parse(window.usageReport);

    window.companyLogin = JSON.parse(window.companyLogin);
    var companyValues   = Object.values(companyLogin);
    window.allLines     = [];
    window.allLabels    = companyValues.length > 0 ? Object.keys(companyValues[0]) : [];
    window.companyKeys  = Object.keys(companyLogin);
    for(var i = 0; i < companyKeys.length ; i ++) window.allLines.push({data: Object.values(companyValues[i]), type: 'line', name: projectPairs[companyKeys[i]]});

    drawCompanyActiveAccount(window.monthLogin);
    drawProjectActiveAccount();

    window.onresize = resizeChart;
    $('#sidebar').on('click', 'div', function(){setTimeout(resizeChart, 100);});

	$('#exportchart').modalTrigger();
});

/**
 * Init companyDailyAnalysis Chart.
 *
 * @param  string $loginData
 * @access public
 * @return void
 */
function drawCompanyActiveAccount(loginData)
{
    var loginData = JSON.parse(loginData);
    var xdata     = Object.keys(loginData);
    var ydata     = Object.values(loginData);

    var myChart = echarts.init(document.getElementById('monthLogin'));
    var option;

    option = {
      xAxis: {
        type: 'category',
        name: window.usageReport.date,
          axisTick: {
              alignWithLabel: true,
              interval: 1
          },
        data: xdata
      },
      yAxis: {
        type: 'value',
        name: window.usageReport.number,
      },
      series: [
        {
          data: ydata,
          type: 'line'
        }
      ]
    };

    option && myChart.setOption(option);
}

/**
 * Init projectDailyAnalysis Chart.
 *
 * @access public
 * @return void
 */
function drawProjectActiveAccount()
{
    var lines          = [];
    var maxY           = 0;
    var minY           = 0;
    var selectProjects = $('#projectusers').data('zui.picker').getValue();
    for(var i = 0; i < selectProjects.length ; i ++)
    {
        var index = companyKeys.indexOf(selectProjects[i]);
        if(index >= 0)
        {
            lines.push(allLines[index]);
            var max = Math.max.apply(null, allLines[index].data)
            var min = Math.min.apply(null, allLines[index].data)
            maxY = max > maxY ? max : maxY;
            minY = min > minY ? min : minY;
        }
    }

    var myChart = echarts.init(document.getElementById('projectLogin'));
    var option;
    option = {
        legend: {},
        xAxis: {
            type: 'category',
            name: window.usageReport.date,
            axisTick: {
                alignWithLabel: true,
                interval: 1
            },
            data: allLabels
        },
        yAxis: {
            type: 'value',
            name: window.usageReport.number,
            max: maxY + 2,
            min: minY - 2 >= 0 ? minY - 2 : minY
        },
        series: lines
    };

    option && myChart.setOption(option, true);
}

/**
 * Resize charts.
 *
 * @access public
 * @return void
 */
function resizeChart()
{
    var charts = $('.echart-chart');
    var myChart;
    for(var i = 0; i < charts.length ; i ++)
    {
        myChart = echarts.init(charts[i]);
        myChart.resize();
    }
}
