<?php
/**
 * The usegereport view file of report module of ZenTaoPMS.
 *
 * @copyright   Copyright 2009-2022 青岛易软天创网络科技有限公司(QingDao Nature Easy Soft Network Technology Co,LTD, www.cnezsoft.com)
 * @license     ZPL(http://zpl.pub/page/zplv12.html) or AGPL(https://www.gnu.org/licenses/agpl-3.0.en.html)
 * @author      Mengyi Liu <liumengyi@easycorp.ltd>
 * @package     report
 * @version     $Id$
 * @link        https://www.zentao.net
 */
?>
<?php include $app->getModuleRoot() . 'common/view/header.html.php';?>
<?php js::import($this->config->webRoot . 'js/echarts/echarts.common.min.js'); ?>
<?php js::set('usageReport', json_encode($lang->usageReport));?>
<?php js::set('report', $report);?>
<?php js::set('monthLogin', !empty($report->accountDailyActivity) ? json_encode($report->accountDailyActivity) : '{}');?>
<?php js::set('companyLogin', !empty($report->projectDailyActivity) ? json_encode($report->projectDailyActivity) : '{}');?>
<?php js::set('projectPairs', $projectPairs);?>
<?php js::set('selectProjects', $selectProjects);?>
<div id='mainContent' class='main-row'>
  <div class='side-col' id='sidebar'>
    <div class="sidebar-toggle"><i class="icon icon-angle-left"></i></div>
    <div class="cell">
      <div class='panel'>
        <div class='panel-heading'>
          <div class='panel-title'><?php echo $title;?></div>
        </div>
        <div class='panel-body'>
          <div class='list-group'>
            <?php
            if(empty($reportList))
            {
                echo '<div class="table-empty-tip"><p><span class="text-muted">' . $lang->error->noData . '</span></p></div>';
            }
            else
            {
                foreach($reportList as $reportData)
                {
                    $class = ($year == $reportData->year and $month == $reportData->month) ? 'selected' : '';
                    $label = sprintf($lang->usageReport->dateForm, $reportData->year, $reportData->month);
                    echo html::a($this->createLink('report', 'usagereport', "year={$reportData->year}&month={$reportData->month}"), '<i class="icon icon-file-text"></i> ' . $label, '', "class='$class' title='$label'");
                }
            }
            ?>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class='main-col'>
    <div class="cell">
      <div class='row panel'>
        <?php if(empty($report)):?>
        <div class="table-empty-tip">
          <p><span class="text-muted"><?php echo $lang->error->noData;?></span></p>
        </div>
        <?php else:?>
        <div class="panel-heading">
          <div class="panel-title">
            <div class="table-row" id='conditions'>
              <div class="col-xs text-center">
                <span class='report-title'><?php echo sprintf($lang->usageReport->dateForm, $year, $month) . $title;?></span>
                <?php if(common::hasPriv('report', 'exportUsageReport')):?>
                <nav class="panel-actions btn-toolbar"><?php echo html::a($this->createLink('report', 'exportUsageReport', "year=$year&month=$month"), $lang->export, '', "class='btn btn-primary btn-sm' data-width='60%' id='exportchart'");?></nav>
                <?php endif;?>
              </div>
            </div>
            <div class="table-row" id='dates'>
              <div class="col-xs text-right">
                <span class="date-title"><?php echo $lang->usageReport->begin;?></span>
                <span class="date-value btn-info"><?php echo date('Y-m-01', strtotime("$year-$month"));?></span>
              </div>
              <div class="col-xs">
                <span class="date-title"><?php echo $lang->usageReport->end;?></span>
                <span class="date-value btn-info"><?php echo date('Y-m-t', strtotime("$year-$month"));?></span>
              </div>
            </div>
          </div>
        </div>
        <div class='table-row chart-row col-sm-6'>
          <div class='main-col'>
            <div class="detail">
              <div class="detail-content">
                <table class='table table-data data-stats'>
                  <tbody>
                    <tr>
                      <td class='detail-title h3' colspan='4'>
                        <?php echo $lang->usageReport->usageDataAnalysis;?>
                        <a data-toggle='tooltip' title='<?php echo $lang->usageReport->usageDataAnalysisDesc;?>'><i class='icon-help'></i></a>
                      </td>
                    </tr>
                    <tr>
                      <!--
                      <th><?php echo $lang->usageReport->licenseType;?></th>
                      <td><?php echo zget($lang->usageReport->licenseTypeList, $report->licenseType);?></td>
                      <th><?php echo $lang->usageReport->licensedAccounts;?></th>
                      <td><?php echo !empty($report->licensedAccounts) ? $report->licensedAccounts : $lang->unlimited;?></td>
                      -->
                      <th><?php echo $lang->usageReport->currentVersion;?></th>
                      <td><?php echo str_replace(array('pms', 'pro', 'biz', 'max'), array($lang->pmsName, $lang->proName, $lang->bizName, $lang->maxName), $report->version);?></td>
                      <th><?php echo $lang->usageReport->activeProduct;?></th>
                      <td><?php echo $report->activeProduct;?></td>
                    </tr>
                    <tr>
                      <th><?php echo $lang->usageReport->onlineDays;?></th>
                      <td><?php echo $report->onlineDays;?><span class='c-day'><?php echo ' ' . $lang->report->day;?></span></td>
                      <th><?php echo $lang->usageReport->activeProject;?></th>
                      <td><?php echo $report->activeProject;?></td>
                      <th><?php echo $lang->usageReport->projectModel;?></th>
                      <td colspan='3'><?php echo str_replace(array('scrum', 'waterfall', 'kanban'), array($lang->project->scrum, $lang->project->waterfall, $lang->project->kanban), $report->projectModel);?></td>
                    </tr>
                    <tr>
                      <td class='detail-title' colspan='4'>
                        <?php echo $lang->usageReport->activeAccountAnalysis;?>
                        <a data-toggle='tooltip' title='<?php echo $lang->usageReport->activeAccountAnalysisDesc;?>'><i class='icon-help'></i></a>
                      </td>
                    </tr>
                  </tbody>
                </table>
                <table class='table table-bordered table-fixed'>
                  <tbody>
                    <tr class='text-center'>
                      <th><?php echo $lang->usageReport->month;?></th>
                      <th><?php echo $lang->usageReport->activeAccounts;?></th>
                      <th><?php echo $lang->usageReport->allAccounts;?></th>
                      <th><?php echo $lang->usageReport->activeProportion;?></th>
                    </tr>
                    <tr class='text-center'>
                      <td><?php echo $lang->usageReport->thisMonth;?></th>
                      <td><?php echo !empty($report->activeAccounts->active) ? $report->activeAccounts->active : '0';?></td>
                      <td><?php echo !empty($report->activeAccounts->total)  ? $report->activeAccounts->total  : '0';?></td>
                      <td><?php echo (!empty($report->activeAccounts->ratio) ? $report->activeAccounts->ratio  : '0') . '%';?></td>
                    </tr>
                    <tr class='text-center'>
                      <td><?php echo $lang->usageReport->lastMonth;?></th>
                      <td><?php echo !empty($lastReport->activeAccounts->active) ? $lastReport->activeAccounts->active : '0';?></td>
                      <td><?php echo !empty($lastReport->activeAccounts->total)  ? $lastReport->activeAccounts->total  : '0';?></td>
                      <td><?php echo (!empty($lastReport->activeAccounts->ratio) ? $lastReport->activeAccounts->ratio  : '0') . '%';?></td>
                    </tr>
                  </tbody>
                </table>
                <table class='table table-data'>
                  <tbody>
                    <tr>
                      <td class='detail-title' colspan='4'><?php echo $lang->usageReport->companyDailyAnalysis;?>
                        <div id='monthLogin' class='echart-chart'></div>
                      </td>
                    </tr>
                    <tr>
                      <td colspan='4'></td>
                    </tr>
                    <tr>
                      <td class='detail-title' colspan='4'>
                        <?php echo $lang->usageReport->projectComparisonAnalysis;?>
                        <a data-toggle='tooltip' title='<?php echo $lang->usageReport->projectComparisonAnalysisDesc;?>'><i class='icon-help'></i></a>
                      </td>
                    </tr>
                  </tbody>
                </table>
                <table class='table table-bordered table-fixed'>
                  <tbody>
                    <tr class='text-center'>
                      <th><?php echo $lang->report->project;?></th>
                      <th><?php echo $lang->usageReport->projectActiveAccounts;?></th>
                      <th><?php echo $lang->usageReport->projectAllAccounts;?></th>
                      <th><?php echo $lang->usageReport->activeProportion;?></th>
                    </tr>
                    <?php
                    if(!empty($report->activeProjects))
                    {
                        foreach($report->activeProjects as $projectID => $projectData)
                        {
                            echo "<tr class='text-center'>";
                            echo '<td>' . zget($projectPairs, $projectID) . '</td>';
                            echo '<td>' . (!empty($projectData->active) ? $projectData->active : '0') . '</td>';
                            echo '<td>' . (!empty($projectData->total)  ? $projectData->total  : '0') . '</td>';
                            echo '<td>' . (!empty($projectData->ratio)  ? $projectData->ratio  : '0') . '%</td>';
                            echo '</tr>';
                        }
                    }
                    ?>
                  </tbody>
                </table>
                <table class='table table-data'>
                  <tbody>
                    <tr>
                      <td class='detail-title' colspan='4'>
                        <?php echo $lang->usageReport->projectDailyAnalysis;?>
                        <a data-toggle='tooltip' title='<?php echo $lang->usageReport->projectDailyAnalysisDesc;?>'><i class='icon-help'></i></a>
                      </td>
                    </tr>
                    <tr>
                      <td colspan='4'>
                       <?php echo html::select('projectusers[]', $projectPairs, $selectProjects, "class='form-control picker-select' multiple");?>
                       <?php echo html::a('javascript:drawProjectActiveAccount()', "<i class='icon-search muted'></i> " . $lang->report->query, '', "class='btn'");?>
                      </td>
                    </tr>
                    <tr>
                      <td colspan='4'>
                        <div id='projectLogin' class='echart-chart'></div>
                      </td>
                    </tr>
                  </tbody>
                </table>
              </div>
            </div>
          </div>
        </div>
        <?php endif;?>
      </div>
    </div>
  </div>
</div>
<?php include $app->getModuleRoot() . 'common/view/footer.html.php';?>
